#-----------------------------------------------------------------------------
# 8/21/07
# MorphMirror 2
# by Ockham
# Slight fix 9/30/2013: expanded listbox to avoid crash, fixed raise Exception()
#-----------------------------------------------------------------------------

from Tkinter import *
import tkFileDialog
import poser
import os
scene = poser.Scene()
SelFig=scene.CurrentFigure()
SelActor=scene.CurrentActor()
if not SelActor.ItsFigure(): raise Exception("Actor not a body part.")
if SelFig.Name() != SelActor.ItsFigure().Name():
    raise Exception("Actor not on selected figure.")

#-----------------------------------------------------------------------------

def ReplaceLbyR(Given):
   UpperGiven=string.upper(Given)
   ReturnList=[]

   # Generate all possible switcheroos, and try them.  The arg is the original
   # part name.

   # If the given name has LEFT anywhere in it, we give back a list
   # consisting of (1) the same name (2) the name with LEFT replaced by RIGHT
   # and (3) the name with LEFT replaced by R.

   # If no LEFT, we check for any L.

   # If the given name has L anywhere in it, we give back a list
   # consisting of (1) the same name (2) the name with L replaced by RIGHT
   # and (3) the name with L replaced by R.

   # Most of these replacements will be useless; it's up to the calling routine
   # to check their existence.

   # Look for left:
   if string.count(UpperGiven,'LEFT'):
       # Really only three possibilities here.
       if string.count(Given,'Left'):
           ReturnList.append(string.replace(Given,'Left','Right'))
           ReturnList.append(string.replace(Given,'Left','R'))
       elif string.count(Given,'LEFT'):
           ReturnList.append(string.replace(Given,'LEFT','RIGHT'))
           ReturnList.append(string.replace(Given,'LEFT','R'))
       elif string.count(Given,'left'):
           ReturnList.append(string.replace(Given,'left','right'))
           ReturnList.append(string.replace(Given,'left','r'))
   elif string.count(UpperGiven,'L'):
       # Replace each occurrence separately. Most of these will be stupid.
       for i in range(len(Given)):
           if Given[i]=='l':
               NewGiven=Given[:i]+'r'+Given[(i+1):] # make a copy
               ReturnList.append(NewGiven)
           if Given[i]=='L':
               NewGiven=Given[:i]+'R'+Given[(i+1):] # make a copy
               ReturnList.append(NewGiven)

   return ReturnList

#-----------------------------------------------------------------------------

def ReplaceRbyL(Given):
   UpperGiven=string.upper(Given)
   ReturnList=[]

   # Trying a different approach.  Generate all possible switcheroos, and
   # try them.  The args are the original morph name and an IncludeSame flag.
   # IncludeSame should only be TRUE when using an opposite-side part, where the
   # most likely case is that the swapper is same MT name.
   # On a midline part, set it FALSE so we don't just hit the original MT.

   # If the given name has LEFT anywhere in it, we give back a list
   # consisting of (1) the same name (2) the name with LEFT replaced by RIGHT
   # and (3) the name with LEFT replaced by R.

   # If no LEFT, we check for any L.

   # If the given name has L anywhere in it, we give back a list
   # consisting of (1) the same name (2) the name with L replaced by RIGHT
   # and (3) the name with L replaced by R.

   # Most of these replacements will be useless; it's up to the calling routine
   # to check their existence.

   # Look for left:
   if string.count(UpperGiven,'RIGHT'):
       # Really only three possibilities here.
       if string.count(Given,'Right'):
           ReturnList.append(string.replace(Given,'Right','Left'))
           ReturnList.append(string.replace(Given,'Right','L'))
       elif string.count(Given,'RIGHT'):
           ReturnList.append(string.replace(Given,'RIGHT','LEFT'))
           ReturnList.append(string.replace(Given,'RIGHT','L'))
       elif string.count(Given,'right'):
           ReturnList.append(string.replace(Given,'right','left'))
           ReturnList.append(string.replace(Given,'right','l'))
   elif string.count(UpperGiven,'R'):
       # Replace each occurrence separately. Most of these will be stupid.
       for i in range(len(Given)):
           if Given[i]=='r':
               NewGiven=Given[:i]+'l'+Given[(i+1):] # make a copy
               ReturnList.append(NewGiven)
           if Given[i]=='R':
               NewGiven=Given[:i]+'L'+Given[(i+1):] # make a copy
               ReturnList.append(NewGiven)

   return ReturnList
#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("Morph mirror")

        self.StatusEntry = Entry(self.master,width=40)
        self.StatusEntry.grid(row=0,column=0,columnspan=2)

        # Lists
        self.ListScroll = Scrollbar(self.master, orient=VERTICAL)
        self.ListScroll.grid( row=2, column=0,sticky=N+S+E)
        self.List = Listbox(self.master, height=15, width=36, selectmode=SINGLE,yscrollcommand = self.ListScroll.set,exportselection=0)
        self.List.grid( row=2, column=1)
        # Set the scrollbar to work
        self.ListScroll["command"] = self.List.yview

        # Go/nogo buttons.
        self.buttonGo1 = Button(self.master, text="Midline", command=self.HandleGoSame)
        self.buttonGo1.grid(row=3, column=0)
        self.buttonGo2 = Button(self.master, text="Opposite", command=self.HandleGoOpp)
        self.buttonGo2.grid(row=3, column=1)

        self.buttonCancel = Button(self.master, text="Cancel", command=self.HandleCancel)
        self.buttonCancel.grid(row=3, column=2)

        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)
        # Fill the list with MTs on current actor
        for P in SelActor.Parameters():
             if P.IsMorphTarget():
                 self.List.insert(END,P.Name())


    # - - - - - - - - - - - - - - - - - -

    def ShowStatus(self,S): # Just saving repetition
        self.StatusEntry.delete(0,END)
        self.StatusEntry.insert(0,S)
        self.StatusEntry.update_idletasks()

    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        if scene: scene.ProcessSomeEvents()
        root.lift()
        root.after(100, self.Update)

    # - - - - - - - - - - - - - - - - - -

    def HandleGoSame(self):
        # Action here
        Sels=self.List.curselection()
        Name=self.List.get(int(Sels[0]))
        G=SelActor.Geometry()
        OrigMorph=SelActor.Parameter(Name)
        MirrName=Name+'_MIRROR'
        SelActor.SpawnTarget(MirrName)
        MirrParm=SelActor.Parameter(MirrName)
        for OrigV in range(G.NumVertices()):
            OrigVert=G.Vertex(OrigV)
            OrigX=OrigVert.X()
            OrigY=OrigVert.Y()
            OrigZ=OrigVert.Z()
            dX=None
            dY=None
            dZ=None
            try:
                (dX,dY,dZ)=OrigMorph.MorphTargetDelta(OrigV)
            except:
                pass
            if dX or dY or dZ:
                for MirrV in range(G.NumVertices()):
                    MirrVert=G.Vertex(MirrV)
                    MirrX=MirrVert.X()
                    MirrY=MirrVert.Y()
                    MirrZ=MirrVert.Z()
                    if abs(MirrX+OrigX)<0.0001: # Allow for very slight difference
                        if abs(MirrY-OrigY)<0.0001: # Allow for very slight difference
                            if abs(MirrZ-OrigZ)<0.0001: # Allow for very slight difference
                                MirrParm.SetMorphTargetDelta(MirrV,-dX,dY,dZ)

        self.master.destroy()

    # - - - - - - - - - - - - - - - - - -

    def HandleGoOpp(self):
        # Try to locate the opposite:
        # Note: Sel here means the currently selected part; Opp means the part on opp side.
        SelName=SelActor.Name()
        Sels=self.List.curselection()
        OrigMorphName=self.List.get(int(Sels[0]))
        LRList=ReplaceLbyR(SelName)
        RLList=ReplaceRbyL(SelName)
        # Try the names:
        OppActor=None
        for OppName in LRList:
            try:
                OppActor=SelFig.Actor(OppName)
            except:
                OppActor=None
            if OppActor: break

        if not OppActor:
            for OppName in RLList:
                try:
                    OppActor=SelFig.Actor(OppName)
                except:
                    OppActor=None
                if OppActor: break

        if OppActor == None:
            self.ShowStatus("Can't find opposite body part!")
            return

        SelG=SelActor.Geometry()
        OppG=OppActor.Geometry()
        OrigMorph=SelActor.Parameter(OrigMorphName)
        MirrName=SelName+'_MIRROR'
        OppActor.SpawnTarget(MirrName) # Create the target parm
        MirrParm=OppActor.Parameter(MirrName) # Now fill it with deltas
        for OrigV in range(SelG.NumVertices()):
            OrigVert=SelG.Vertex(OrigV)
            dX=None
            dY=None
            dZ=None
            try: # Skip zeros
                (dX,dY,dZ)=OrigMorph.MorphTargetDelta(OrigV)
            except:
                pass
            if dX or dY or dZ: # If there is a delta at this V:
                for MirrV in range(OppG.NumVertices()):
                    MirrVert=OppG.Vertex(MirrV)
                    OrigX=OrigVert.X()
                    OrigY=OrigVert.Y()
                    OrigZ=OrigVert.Z()
                    MirrX=MirrVert.X()
                    MirrY=MirrVert.Y()
                    MirrZ=MirrVert.Z()
                    if abs(MirrX+OrigX)<0.0001: # Allow for very slight difference
                        if abs(MirrY-OrigY)<0.0001: # Allow for very slight difference
                            if abs(MirrZ-OrigZ)<0.0001: # Allow for very slight difference
                                MirrParm.SetMorphTargetDelta(MirrV,-dX,dY,dZ)

        self.master.destroy()

    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
